extern "C"{
__global__ void computeFract(double* xvect, double* yvect, int xsize, int ysize, int nmax, double* output)
{

	int i  = blockIdx.x  * blockDim.x + threadIdx.x;
	int j  = blockIdx.y  * blockDim.y + threadIdx.y;
    double x, xtemp, y, x0, y0;
    int k = 0;

    x = xvect[i];
    y = yvect[j];
    x0 = x;
    y0 = y;

    while((x*x + y*y) < 4 && k < nmax )
    {
        xtemp = x*x - y*y + x0;
        y = 2*x*y + y0;
        x = xtemp;
        k++;
    }

    output[ j + i * xsize ] = k + 1 - (__logf(__logf(sqrt(x*x + y*y)))/__logf(2));
}
}
