// Sources : Jonathan Blanchard (http://jblopen.com/node/18)
// Modified by : DIGITEO - 2011 - Cdric DELAMARRE

stacksize('max');
nmax = 800;
xmin = 0.2675;
xmax = 0.2685;
ymin = 0.591;
ymax = 0.592;
xsize = 1000;
ysize = 1000;

xvect = linspace( xmin, xmax, xsize );
yvect = linspace( ymin, ymax, ysize );

d_xvect = gpuSetData(xvect);
d_yvect = gpuSetData(yvect);
d_out   = gpuSetData(zeros(xsize,ysize));

bin=gpuBuild("fract");
Kernel=gpuLoadFunction(bin,"computeFract");

lst=list(d_xvect,d_yvect,int32(xsize),int32(ysize),int32(nmax),d_out);
gpuApplyFunction(Kernel,lst,2,2,500,500);

res = gpuGetData(d_out);

fact = (max(res)) / 512
res = res./fact;

map = hotcolormap(512);
cmap = [map(:,3), map(:,2), map(:,1)];

f=get("current_figure");
f.color_map = cmap;
f.auto_resize = "off";
f.axes_size = [1000,1000];
f.figure_size = [800,800];

clf();
a=get("current_axes");
a.margins = [0,0,0,0];
Matplot(res, "080");

