// =============================================================================
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011 - DIGITEO - Cedric DELAMARRE
//
//  This file is distributed under the same license as the Scilab package.
// =============================================================================

//==============================================================================
// Benchmark for addition product on GPU
//==============================================================================

// <-- BENCH NB RUN : 10 -->

stacksize('max');

A=rand(1000,1000);
B=rand(1000,1000);
n = 100

// <-- BENCH START -->

[GPU dA dB]=gpuAdd(A,B,[1 12]);

for i = 0:n,
    GPU1=gpuAdd(GPU,dB,[1 0]);GPU=gpuFree(GPU);
    GPU=gpuAdd(dA,GPU1,[1 0]);GPU1=gpuFree(GPU1);
end;

GPU1=gpuAdd(GPU,dB,[1 0]);GPU=gpuFree(GPU);
CPU=gpuAdd(dA,GPU1,[0 0]);GPU1=gpuFree(GPU1);

// <-- BENCH END -->

dA=gpuFree(dA);			
dB=gpuFree(dB);
